unit Memoes;

(***********************************************************************
 *                                                                     *
 *  Copyright (C) 1996-1997                                            *
 *  Erol S. Uzuner                                                     *
 *                                                                     *
 *  Modul       :       Memoes                                         *
 *  Version     :       1.0 (26.08.97)                                 *
 *                                                                     *
 *  Beschreibung:      Memoes Komponente                               *
 *                                                                     *
 *  Autor       :       Erol S. Uzuner                                 *
 *                                                                     *
 *  Datum       :       Die Aug 26.08.97  23:37:00 1997                *
 *                                                                     *
 *                                                                     *
 *  Aenderungen :                                                      *
 *  Datum        Autor          Beschreibung                           *
 *                                                                     *
 ***********************************************************************)


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TMemoes = class(TMemo)
  private
    { Private-Deklarationen }
    FTopGap, FLeftGap, FRightGap, FBottomGap : Integer;
    procedure SetEditRect;
    procedure WMWindowPosChanged(var Message: TWMWindowPosChanged); message WM_WINDOWPOSCHANGED;
  protected
    { Protected-Deklarationen }
    procedure CreateWnd; override;
    procedure CreateParams(var Params: TCreateParams); override;

    procedure setLeftGap(value : Integer);
    procedure setTopGap(value : Integer);
    procedure setRightGap(value : Integer);
    procedure setBottomGap(value : Integer);
  public
    { Public-Deklarationen }
    constructor Create(AOwner : TComponent);override;
    destructor Destroy; override;
  published
    { Published-Deklarationen }
      property GapLeft : Integer read FLeftGap write setLeftGap default 0;
      property GapTop : Integer read FTopGap write setTopGap default 0;
      property GapRight : Integer read FRightGap write setRightGap default 0;
      property GapBottom : Integer read FBottomGap write setBottomGap default 0;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('sarcon', [TMemoes]);
end;

constructor TMemoes.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csAcceptsControls];
  FLeftGap := 0;
  FTopGap := 0;
  FRightGap := 0;
  FBottomGap := 0;
end;

destructor TMemoes.Destroy;
begin

  inherited Destroy;
end;

procedure TMemoes.WMWindowPosChanged(var Message: TWMWindowPosChanged);
begin
  inherited;
  SetEditRect;
end;

procedure TMemoes.CreateWnd;
begin
  inherited CreateWnd;
  SetEditRect;
end;

procedure TMemoes.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or WS_CLIPCHILDREN;
end;

procedure TMemoes.SetEditRect;
var
  Loc: TRect;
begin
  SetRect(Loc, FLeftGap, FTopGap, (ClientWidth -1) -FRightGap, (ClientHeight + 1) - FBottomGap);
  SendMessage(Handle, EM_SETRECTNP, 0, LongInt(@Loc));
end;


procedure TMemoes.setLeftGap(value : Integer);
begin
 if (FLeftGap <> value) AND (value > -1) then begin
   FLeftGap := value;
   ReCreateWnd;
 end;
end;

procedure TMemoes.setTopGap(value : Integer);
begin
  if (FTopGap <> value) AND (value > -1) then begin
   FTopGap := value;
   ReCreateWnd;
 end;
end;

procedure TMemoes.setRightGap(value : Integer);
begin
 if (FRightGap <> value) AND (value > -1) then begin
   FRightGap := value;
   ReCreateWnd;
 end;
end;

procedure TMemoes.setBottomGap(value : Integer);
begin
 if (FBottomGap <> value) AND (value > -1) then begin
   FBottomGap := value;
   ReCreateWnd;
 end;
end;

end.
